#!/bin/bash -xe
export PATH=/bin:/usr/bin:/sbin:/usr/sbin

slx=/home/hpa/syslinux/git.lwip
#sub=
sub=boot/syslinux/

#c=32768
c=256
h=255
s=63

rm -rf gen
mkdir -p gen/$sub
if [ "$fs" = vfat ]; then
  cp -rL src/. gen/${sub}
else
  cp -a src/. gen/${sub}
fi
find $slx/com32 \( -name '*.c32' -o -name '*.dep' \) -exec cp -f '{}' gen/${sub} \;
cp -f $slx/*/*.com gen/${sub}
cp -f $slx/core/isolinux.bin gen/${sub}
cp -f $slx/memdisk/memdisk gen/${sub}

for fs in ext2 ext4 vfat btrfs; do

rm -f $fs.img
if true; then
  # This makes a sparse file
  perl -e "truncate(STDOUT, $c*$h*$s*512);" > $fs.img
  fdisk $fs.img <<EOF
x
c
$c
h
$h
s
$s
r
n
p
1


a
1
w
EOF
  dd if=$slx/mbr/mbr.bin of=$fs.img bs=440 count=1 conv=notrunc
  offset=`perl -e 'seek(STDIN,446+8,0); read(STDIN,$o,4); print unpack("V", $o)*512, "\n";' < $fs.img`
else
  offset=`$slx/utils/mkdiskimage -o $fs.img $c $h $s`
fi
sync
loopdev=`losetup -o $offset -fs $fs.img`
mkfs.$fs $loopdev

mkdir -p mnt
mount -t $fs $loopdev mnt
if [ "$fs" = vfat ]; then
  cp -rL gen/. mnt/
else
  cp -a gen/. mnt/
fi
sync
strace $slx/extlinux/extlinux -i mnt/$sub
umount mnt
sync
losetup -d $loopdev
sync

if [ -n "$SUDO_UID" ]; then
    chown $SUDO_UID:$SUDO_GID $fs.img
fi

done

mkisofs -o iso9660.iso -v -J -f -r -l \
    -b ${sub}isolinux.bin -c boot.cat \
    -no-emul-boot -boot-load-size 4 -boot-info-table \
    gen
$slx/utils/isohybrid -partok -ctrlhd0 iso9660.iso

if [ -n "$SUDO_UID" ]; then
    chown $SUDO_UID:$SUDO_GID iso9660.iso
fi

if [ -n "$SUDO_UID" ]; then
    chown -R $SUDO_UID:$SUDO_GID mnt gen
fi
